#include "StereoDevice.h"
#include <iostream>


static svsStereoProcess stereoproc;		// stereo processor
static svsMultiProcess mstereoproc;		// stereo processor

StereoDevice::StereoDevice() {
    tableColor.colors[0].min = 0;
    tableColor.colors[0].max = 50;
    tableColor.colors[0].color = cv::Vec3b(255, 0, 0);

    tableColor.colors[1].min = 51;
    tableColor.colors[1].max = 100;
    tableColor.colors[1].color = cv::Vec3b(0, 255, 0);

    tableColor.colors[2].min = 101;
    tableColor.colors[2].max = 150;
    tableColor.colors[2].color = cv::Vec3b(255, 255, 255);

    tableColor.colors[3].min = 151;
    tableColor.colors[3].max = 200;
    tableColor.colors[3].color = cv::Vec3b(100, 100, 100);

    tableColor.colors[4].min = 201;
    tableColor.colors[4].max = 225;
    tableColor.colors[4].color = cv::Vec3b(0, 255, 255);

    tableColor.colors[5].min = 226;
    tableColor.colors[5].max = 250;
    tableColor.colors[5].color = cv::Vec3b(200, 200, 200);

    tableColor.colors[6].min = 251;
    tableColor.colors[6].max = 300;
    tableColor.colors[6].color = cv::Vec3b(255, 255, 0);

    tableColor.colors[7].min = 350;
    tableColor.colors[7].max = 10000;
    tableColor.colors[7].color = cv::Vec3b(0, 0, 255);
}

bool StereoDevice::calcDisparity()
{
	bool b;
	//b = mstereoproc.CalcStereo(svsstereoimage);
	b = stereoproc.CalcStereo(svsstereoimage);
	disparity = svsstereoimage->Disparity();

	/*int indexSHORT = 0;

	for(int i = 0; i < height; i++)
	{
		for(int j = 0; j < width; j++)
		{
			if(disparity[indexSHORT] < 0) {
				disparityImage.at<cv::Vec3b>(i,j) = cv::Vec3b(0, 0, 0);
			}
			else if (disparity[indexSHORT] <= tableColor.colors[0].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[0].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[1].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[1].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[2].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[3].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[4].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[4].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[5].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[5].color;
			}			
			else if (disparity[indexSHORT] <= tableColor.colors[6].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[6].color;
			}
			else {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[7].color;
			}

			++indexSHORT;
		}
	}*/
	return b;
}

cv::Mat StereoDevice::processDisparity() {
	int indexSHORT = 0;

	for(int i = 0; i < height; i++)
	{
		for(int j = 0; j < width; j++)
		{
			if(disparity[indexSHORT] < 0) {
				disparityImage.at<cv::Vec3b>(i,j) = cv::Vec3b(0, 0, 0);
			}
			else if (disparity[indexSHORT] <= tableColor.colors[0].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[0].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[1].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[1].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[2].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[3].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[4].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[4].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[5].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[5].color;
			}
			else if (disparity[indexSHORT] <= tableColor.colors[6].max) {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[6].color;
			}
			else {
				disparityImage.at<cv::Vec3b>(i,j) = tableColor.colors[7].color;
			}

			++indexSHORT;
		}
	}

	return disparityImage;
}

bool StereoDevice::calc3D(int x, int y, double *X, double *Y, double *Z)
{
	return mstereoproc.CalcPoint3D(x,y,svsstereoimage,X,Y,Z);	
}
