/*
 * player.h
 *
 *  Created on: Nov 17, 2012
 *      Author: Andrea Pennisi
 */

#ifndef PLAYER_H_
#define PLAYER_H_

#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/legacy/compat.hpp>
#include <opencv2/imgproc/imgproc_c.h>
#include "findBall.h"
//#include "svsclass.h"
#include <math.h>

typedef struct {
	int b;
	int g;
	int r;
} Pixel;

typedef struct{
	cv::Point2i pos;
	std::string role;
	cv::Point3f pos3D;
} previousPosition;

class player {
public:
	player();
	player(const cv::Point2i topLeft, const cv::Point2i bottomRight,
			IplImage *frame, const svs3Dpoint *adjustedPts3D);
	bool getSatus() {return status;};
	std::string getRole() {return role;};
	void setRole(const std::vector<previousPosition> startedPosition, std::vector<previousPosition>& lastPosition);
	cv::Point2f getTopLeft(){return topLeft;};
	cv::Point2f getBottomRight(){return bottomRight;};
	void drawBoundingBox(const svs3Dpoint *adjustedPts3D, svsStereoImage* svsstereoimage, const IplImage *fgImage);
	static void drawBlobInPlanView(const svs3Dpoint *adjustedPts3D, IplImage *planview,
			const double planViewScale, const double planViewTranslation, std::vector<player*> Players);
	static bool checkOffside(std::vector<player*> Players, findBall &ball);
	virtual ~player();
private:
	cv::Point2i topLeft;
	cv::Point2i bottomRight;
	cv::Point3f bottomRight3D;
	cv::Point3f topLeft3D;
	std::string role;
	Pixel color;
	IplImage *frame;
	bool status;
	void setStatus(bool status){this->status = status;};
	static player *findPlayer(std::string role, std::vector<player*> Players);
};

#endif /* PLAYER_H_ */
