/*
 *  stereograbber.h
 *
 *  Author: Domenico Bloisi
 *  domenicobloisi@yahoo.com
 *  Copyright 2012
 */

#ifndef STEREOGRABBER_H_
#define STEREOGRABBER_H_

#include "grabber.h"

#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <algorithm>
#include "VidereStereoDevice.h"

#include <opencv2/highgui/highgui.hpp>
#include <opencv2/core/core.hpp>

class StereoGrabber: public Grabber
{
	private:
		StereoDevice *sdev;
		VidereStereoDevice vdev;
	public:
		StereoGrabber(int width, int height, int fps, bool enableRectification, int prev_offset=1);
		virtual ~StereoGrabber();
		virtual bool getData();
		int getWidth(){return width;};
		int getHeight(){return height;};
		virtual unsigned long getTimestamp();
		virtual unsigned long getPrevTimestamp();
		double getFps(){return fps;};
};

#endif /*LIVEGRABBER_H_*/

